import objectdraw.*;
import java.awt.Color;

/**
 * Write a description of class BouncyBall here.  Submissions
 * that do not replace this paragraph with your own description
 * that includes all required items in the class submission
 * guidelines are subject to penalties.
 * 
 * @author (your name) based on starter code by Jim Teresco
 */
public class BouncyBall extends ActiveObject
{
    private static final int PAUSE_TIME = 30;
    
    private FilledOval theBall;
    private DrawingCanvas canvas;
    private double xSpeed, ySpeed;
    
    public BouncyBall(double size, Color initColor, DrawingCanvas c) {
        
        theBall = new FilledOval((c.getWidth()-size)/2, (c.getHeight()-size)/2,
                size, size, c);
        theBall.setColor(initColor);
        
        canvas = c;
        
        start();
    }
    
    public void run() {
        
        // ball starts out moving a little, but your program should later have the ball 
        // start out stationary
        xSpeed = 2;  // make this 0 later!!
        ySpeed = 3;  // make this 0 later!!
        while (true) {
            if (xSpeed < 0 && theBall.getX() < 0) xSpeed = -xSpeed;
            if (xSpeed > 0 && (theBall.getX() + theBall.getWidth()) > canvas.getWidth()) xSpeed = -xSpeed;
            if (ySpeed < 0 && theBall.getY() < 0) ySpeed = -ySpeed;
            if (ySpeed > 0 && (theBall.getY() + theBall.getHeight()) > canvas.getHeight()) ySpeed = -ySpeed;
            
            theBall.move(xSpeed, ySpeed);
            pause(PAUSE_TIME);
        }
    }
}
